/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾļĿ¼FAT_DIR_INFO,:޸ļ,ļĴںʱ */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

/* ޸ָļļ,Cļ޸ΪTXTļ */
/* :   iOldName ԭʼļ */
/* ״̬: USB_INT_SUCCESS = ޸ļɹ,
               ״̬οCH376INC.H */
UINT8	RenameFileName( PUINT8 iOldName )
{
	UINT8			s;
	P_FAT_DIR_INFO	pDir;
	s = CH376FileOpen( iOldName );  /* ԭļ */
	if ( s == USB_INT_SUCCESS ) {
		/* ļд... */
		s = CH376DirInfoRead( );  /* ȡǰļĿ¼ϢFAT_DIR_INFO,ݵڴ */
		if ( s == USB_INT_SUCCESS ) {
			CH376ReadBlock( buf );  /* ڴ滺ȡFAT_DIR_INFOݿ,سsizeof(FAT_DIR_INFO) */
			pDir = (P_FAT_DIR_INFO)buf;  /* ǰļĿ¼Ϣ */
			if ( pDir -> DIR_Name[8] == 'C' && pDir -> DIR_Name[9] == ' ' ) {  /* ļչC */
				pDir -> DIR_Name[8] = 'T';  /* ޸ļչΪTXT */
				pDir -> DIR_Name[9] = 'X';  /* ͬ޸ļ */
				pDir -> DIR_Name[10] = 'T';
				s = CH376DirInfoRead( );  /* ȡǰļĿ¼ϢFAT_DIR_INFO,ݵڴ */
				if ( s == USB_INT_SUCCESS ) {  /* ǰļĿ¼ϢFAT_DIR_INFOѾڴ滺 */
					CH376WriteOfsBlock( &buf[8], 8, 3 );  /* ڲƫƵַ8(ļ)д3ֽ(޸ĵչ) */
					s = CH376DirInfoSave( );  /* ļĿ¼Ϣ */
					if ( s == USB_INT_SUCCESS ) {  /* ɹ޸Ĳ */
						/* ļд... */
					}
				}
			}
			else {  /* ļչC */
			}
		}
		CH376FileClose( FALSE );  /* رļ */
	}
	return( s );
}

/* Ϊָļôںʱ */
/* :   ԭʼļiFileName, µĴںʱ: iCreateDate, iCreateTime */
/* ״̬: USB_INT_SUCCESS = óɹ,
               ״̬οCH376INC.H */
UINT8	SetFileCreateTime( PUINT8 iFileName, UINT16 iCreateDate, UINT16 iCreateTime )
{
	UINT8	s;
	s = CH376FileOpen( iFileName );  /* ļ */
	if ( s == USB_INT_SUCCESS ) {
		/* ļд... */
		s = CH376DirInfoRead( );  /* ȡǰļĿ¼ϢFAT_DIR_INFO,ݵڴ */
		if ( s == USB_INT_SUCCESS ) {
			buf[0] = (UINT8)iCreateTime;  /* ļʱ,8λǰ */
			buf[1] = (UINT8)(iCreateTime>>8);  /* ļʱ,8λں */
			CH376WriteOfsBlock( buf, STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtTime ), 2 );  /* ڲƫƵַDIR_CrtTimeд2ֽ */
			buf[0] = (UINT8)iCreateDate;  /* ļ,8λǰ */
			buf[1] = (UINT8)(iCreateDate>>8);  /* ļ,8λں */
			CH376WriteOfsBlock( buf, STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtDate ), 2 );  /* ڲƫƵַDIR_CrtDateд2ֽ */
			s = CH376DirInfoSave( );  /* ļĿ¼Ϣ */
			if ( s == USB_INT_SUCCESS ) {  /* ɹ޸Ĳ */
				/* ļд... */
			}
		}
		CH376FileClose( FALSE );  /* رļ */
	}
	return( s );
}

main( ) {
	UINT8	s;

	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ10*50mS */
		for ( s = 0; s < 10; s ++ ) {  /* ȴʱ,10*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ʼ̲ԴǷ */
		}
//		s = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
//		if ( s == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
//			buf[ s ] = 0;
//			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
//		}

		printf( "Open and rename CH376HFT.C to CH376HFT.TXT \n" );
		s = RenameFileName( "/CH376HFT.C" );  /* ޸ļ, ļڸĿ¼, Cļ => TXTļ */
		if ( s == ERR_MISS_FILE ) printf( "File /CH376HFT.C not found !\n" );
		mStopIfError( s );
		printf( "Set file create date & time to 2004.06.08 15:39:20 \n" );
		s = SetFileCreateTime( "/CH376HFT.TXT", MAKE_FILE_DATE( 2004, 6, 8 ), MAKE_FILE_TIME( 15, 39, 20 ) );  /* Ϊָļôںʱ */
		mStopIfError( s );

		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
