/* CH376оƬ ģ8λӵӲ V1.0 */
/* ṩI/Oӿӳ */

#include	"HAL.H"

/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH376оƬ
      P2.0                 A0
      P2.6                 CS#    ģĲֻCH376,ôCS#ֱӽӵ͵ƽ,ǿƬѡ
      P3.6                 WR#
      P3.7                 RD#
      P0(8λ˿)         D7-D0       */
sbit	CH376_A0	=	P2^0;
sbit	CH376_CS	=	P2^6;
sbit	CH376_WR	=	P3^6;
sbit	CH376_RD	=	P3^7;
#define	CH376_DATA_DAT_OUT( d )	{ P0 = d; }		/* 򲢿 */
#define	CH376_DATA_DAT_IN( )	( P0 )			/* Ӳ */
#define	CH376_DATA_DIR_OUT( )					/* òڷΪ */
#define	CH376_DATA_DIR_IN( )	{ P0 = 0xFF; }	/* òڷΪ */

#define CH376_INT_WIRE			INT0	/* ٶCH376INT#,δôҲͨѯ״̬˿ʵ */

void	CH376_PORT_INIT( void )  /* ʹͨI/OģⲢڶдʱ,Խгʼ */
{
	CH376_CS = 1;
	CH376_WR = 1;
	CH376_RD = 1;
	CH376_A0 = 0;
	CH376_DATA_DIR_IN( );  /* ò */
}

//void	mDelay0_5uS( void )  /* ʱ0.5uS,ݵƬƵ */
//{
//}

#define	xEndCH376Cmd( )  /* CH376,SPIӿڷʽ */

UINT8	xReadCH376Status( void )  /* CH376״̬,ڲڷʽ */
{
	UINT8	mData;
	CH376_DATA_DIR_IN( );  /* òڷΪ */
	CH376_A0 = 1;
	CH376_CS = 0;
	CH376_RD = 0;  /* Чź, CH376оƬ״̬˿ */
	CH376_CS = 0;  /* ò,ʱ,CH376Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	mData = CH376_DATA_DAT_IN( );  /* CH376Ĳ */
	CH376_RD = 1;  /* ЧĿź, ɲCH376оƬ */
	CH376_CS = 1;
	CH376_A0 = 0;
	return( mData );
}

void	xWriteCH376Cmd( UINT8 mCmd )  /* CH376д */
{
	CH376_DATA_DAT_OUT( mCmd );  /* CH376Ĳ */
	CH376_DATA_DIR_OUT( );  /* òڷΪ */
	CH376_A0 = 1;
	CH376_CS = 0;
	CH376_WR = 0;  /* Чдź, дCH376оƬ˿ */
//	CH376_CS = 0;  /* ò,ʱ,CH376Ҫдȴ40nS */
	CH376_WR = 1;  /* ЧĿź, ɲCH376оƬ */
	CH376_CS = 1;
	CH376_A0 = 0;
	CH376_DATA_DIR_IN( );  /* ֹ */
/*	mDelay0_5uS( ); mDelay0_5uS( ); mDelay0_5uS( );*/  /* ʱ1.5uSȷдڴ1.5uS,״̬ѯ */
}

void	xWriteCH376Data( UINT8 mData )  /* CH376д */
{
	CH376_DATA_DAT_OUT( mData );  /* CH376Ĳ */
	CH376_DATA_DIR_OUT( );  /* òڷΪ */
	CH376_A0 = 0;
	CH376_CS = 0;
	CH376_WR = 0;  /* Чдź, дCH376оƬݶ˿ */
//	CH376_CS = 0;  /* ò,ʱ,CH376Ҫдȴ40nS */
	CH376_WR = 1;  /* ЧĿź, ɲCH376оƬ */
	CH376_CS = 1;
	CH376_DATA_DIR_IN( );  /* ֹ */
//	mDelay0_5uS( );  /* ȷдڴ0.6uS */
}

UINT8	xReadCH376Data( void )  /* CH376 */
{
	UINT8	mData;
//	mDelay0_5uS( );  /* ȷдڴ0.6uS */
	CH376_DATA_DIR_IN( );  /* òڷΪ */
	CH376_A0 = 0;
	CH376_CS = 0;
	CH376_RD = 0;  /* Чź, CH376оƬݶ˿ */
	CH376_CS = 0;  /* ò,ʱ,CH376Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	mData = CH376_DATA_DAT_IN( );  /* CH376Ĳ */
	CH376_RD = 1;  /* ЧĿź, ɲCH376оƬ */
	CH376_CS = 1;
	return( mData );
}

/* ѯCH376ж(INT#͵ƽ) */
UINT8	Query376Interrupt( void )
{
#ifdef	CH376_INT_WIRE
	return( CH376_INT_WIRE ? FALSE : TRUE );  /* CH376жֱӲѯж */
#else
	return( xReadCH376Status( ) & PARA_STATE_INTB ? FALSE : TRUE );  /* δCH376жѯ״̬˿ */
#endif
}

UINT8	mInitCH376Host( void )  /* ʼCH376 */
{
	UINT8	res;
	CH376_PORT_INIT( );  /* ӿӲʼ */
	xWriteCH376Cmd( CMD11_CHECK_EXIST );  /* ԵƬCH376֮ͨѶӿ */
	xWriteCH376Data( 0x65 );
	res = xReadCH376Data( );
//	xEndCH376Cmd( );  // ڷʽҪ
	if ( res != 0x9A ) return( ERR_USB_UNKNOWN );  /* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
	xWriteCH376Cmd( CMD11_SET_USB_MODE );  /* 豸USBģʽ */
	xWriteCH376Data( 0x05 );
	mDelayuS( 20 );
	res = xReadCH376Data( );
//	xEndCH376Cmd( );  // ڷʽҪ
	if ( res == CMD_RET_SUCCESS ) return( USB_INT_SUCCESS );
	else return( ERR_USB_UNKNOWN );  /* ģʽ */
}
