/* CH376оƬ ģSPIӵӲ V1.0 */
/* ṩI/Oӿӳ */

#include	"HAL.H"

/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH376оƬ
      P1.4                 SCS
      P1.5                 SDI
      P1.6                 SDO
      P1.7                 SCK      */
sbit	P14					=	P1^4;
sbit	P15					=	P1^5;
sbit	P16					=	P1^6;
sbit	P17					=	P1^7;
#define	CH376_SPI_SCS			P14		/* ٶCH376SCS */
#define	CH376_SPI_SDI			P15		/* ٶCH376SDI */
#define	CH376_SPI_SDO			P16		/* ٶCH376SDO */
#define	CH376_SPI_SCK			P17		/* ٶCH376SCK */
/*#define	CH376_SPI_BZ			P10*/		/* ٶCH376BZ */

#define CH376_INT_WIRE			INT0	/* ٶCH376INT#,δôҲͨѯжSDO״̬ʵ */

void	CH376_PORT_INIT( void )  /* ʹģSPIдʱ,Խгʼ */
{
/* ӲSPIӿ,ôʹmode3(CPOL=1&CPHA=1)mode0(CPOL=0&CPHA=0),CH376ʱز,½,λǸλǰ */
	CH376_SPI_SCS = 1;  /* ֹSPIƬѡ */
	CH376_SPI_SCK = 1;  /* ĬΪߵƽ,SPIģʽ3,ҲSPIģʽ0,ģ޸ */
/* ˫I/OģSPIӿ,ôڴSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
}

void	mDelay0_5uS( void )  /* ʱ0.5uS,ݵƬƵ */
{
}

void	Spi376OutByte( UINT8 d )  /* SPI8λ */
{  /* ӲSPIӿ,ӦȽдSPIݼĴ,ȻѯSPI״̬ĴԵȴSPIֽڴ */
	UINT8	i;
	for ( i = 0; i < 8; i ++ ) {
		CH376_SPI_SCK = 0;
		if ( d & 0x80 ) CH376_SPI_SDI = 1;
		else CH376_SPI_SDI = 0;
		d <<= 1;  /* λǸλǰ */
		CH376_SPI_SCK = 1;  /* CH376ʱز */
	}
}

UINT8	Spi376InByte( void )  /* SPI8λ */
{  /* ӲSPIӿ,ӦȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
	UINT8	i, d;
	d = 0;
	for ( i = 0; i < 8; i ++ ) {
		CH376_SPI_SCK = 0;  /* CH376ʱ½ */
		d <<= 1;  /* λǸλǰ */
		if ( CH376_SPI_SDO ) d ++;
		CH376_SPI_SCK = 1;
	}
	return( d );
}

#define	xEndCH376Cmd( )	{ CH376_SPI_SCS = 1; }  /* SPIƬѡЧ,CH376,SPIӿڷʽ */

void	xWriteCH376Cmd( UINT8 mCmd )  /* CH376д */
{
#ifdef	CH376_SPI_BZ
	UINT8	i;
#endif
	CH376_SPI_SCS = 1;  /* ֹ֮ǰδͨxEndCH376CmdֹSPIƬѡ */
	mDelay0_5uS( );
/* ˫I/OģSPIӿ,ôȷѾSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
	CH376_SPI_SCS = 0;  /* SPIƬѡЧ */
	Spi376OutByte( mCmd );  /*  */
#ifdef	CH376_SPI_BZ
	for ( i = 30; i != 0 && CH376_SPI_BZ; -- i );  /* SPIæ״̬ѯ,ȴCH376æ,һеʱ1.5uS */
#else
	mDelay0_5uS( ); mDelay0_5uS( ); mDelay0_5uS( );  /* ʱ1.5uSȷдڴ1.5uS,һе״̬ѯ */
#endif
}

#ifdef	FOR_LOW_SPEED_MCU  /* Ҫʱ */
#define	xWriteCH376Data( d )	{ Spi376OutByte( d ); }  /* CH376д */
#define	xReadCH376Data( )		( Spi376InByte( ) )  /* CH376 */
#else
void	xWriteCH376Data( UINT8 mData )  /* CH376д */
{
	Spi376OutByte( mData );
//	mDelay0_5uS( );  /* ȷдڴ0.6uS */
}
UINT8	xReadCH376Data( void )  /* CH376 */
{
//	mDelay0_5uS( );  /* ȷдڴ0.6uS */
	return( Spi376InByte( ) );
}
#endif

/* ѯCH376ж(INT#͵ƽ) */
UINT8	Query376Interrupt( void )
{
#ifdef	CH376_INT_WIRE
	return( CH376_INT_WIRE ? FALSE : TRUE );  /* CH376жֱӲѯж */
#else
	return( CH376_SPI_SDO ? FALSE : TRUE );  /* δCH376жѯжSDO״̬ */
#endif
}

UINT8	mInitCH376Host( void )  /* ʼCH376 */
{
	UINT8	res;
	CH376_PORT_INIT( );  /* ӿӲʼ */
	xWriteCH376Cmd( CMD11_CHECK_EXIST );  /* ԵƬCH376֮ͨѶӿ */
	xWriteCH376Data( 0x65 );
	res = xReadCH376Data( );
	xEndCH376Cmd( );
	if ( res != 0x9A ) return( ERR_USB_UNKNOWN );  /* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
	xWriteCH376Cmd( CMD11_SET_USB_MODE );  /* 豸USBģʽ */
	xWriteCH376Data( 0x05 );
	mDelayuS( 20 );
	res = xReadCH376Data( );
	xEndCH376Cmd( );
#ifndef	CH376_INT_WIRE
#ifdef	CH376_SPI_SDO
	xWriteCH376Cmd( CMD20_SET_SDO_INT );  /* SPISDOŵжϷʽ */
	xWriteCH376Data( 0x16 );
	xWriteCH376Data( 0x90 );  /* SDOSCSƬѡЧʱж */
	xEndCH376Cmd( );
#endif
#endif
	if ( res == CMD_RET_SUCCESS ) return( USB_INT_SUCCESS );
	else return( ERR_USB_UNKNOWN );  /* ģʽ */
}
