;/* 2008.10.18
;****************************************
;**  Copyright  (C)  W.ch  1999-2009   **
;**  Web:  http://www.winchiphead.com  **
;****************************************
;**  USB Host File Interface for CH376 **
;**  TC2.0@PC, KC7.0@MCS51             **
;****************************************
;*/
;/* CH376 ļϵͳӿ */

;/* MCS-51ƬASMԵUļдʾ,֧89C2051,89C51,89C52ȵƬ */
;/* ʾֽڶд,ڽADCģɼӵU̻SDļMY_ADC.TXT,
;   ļôӵļĩβ,ļô½ļ */
; 
; /* A51   CH376HFT.ASM */
; /* L51   CH376HFT.OBJ */
; /* OHX51 CH376HFT */
;

; 89C2051ûвߵĵƬ,ѡģⲢ,ӲSPIģSPI,첽ڵӲͨѶʽ,CЩ
CH376_CMD_PORT			EQU		0BDF1H		; CH376˿ڵI/Oַ
CH376_DAT_PORT			EQU		0BCF0H		; CH376ݶ˿ڵI/Oַ

$INCLUDE		(..\CH376INC.INC)			; ASMͷļ,ö

LED_OUT					EQU		P1.4		; ״ָ̬ʾ

; Ӧóζ
MY_CODE				SEGMENT		CODE
MY_DATA				SEGMENT		DATA

; λж
					CSEG	AT	0000H
					LJMP	ASM_MAIN		; Ƭλ
;					CSEG	AT	0003H		; INT0ж
;					LJMP    InterruptHandle	; CH376жϷ,ʹ"жϷʽ"ж޸

; Ӧóõĳ,ֻС,ַָ,ӳԶַ
					RSEG	MY_CODE
FILE_NAME:			DB	'\MY_ADC.TXT',00H
STR_WRITE_1:		DB	'This is first string,\xd\xa',00H
STR_WRITE_2:		DB	'Second string !\xd\xa',00H

; Ӧóõı,ֻС,ַָ,ӳԶַ
					RSEG	MY_DATA
MY_BUFFER:			DS	64

; Ӧó,ַָ,ӳԶַ
					RSEG	MY_CODE
;
; ʱn΢,ȷ,24MHzƵ
; : A ʱ΢
; ʹ: A, R7
mDelayuS:			MOV		R7,A
mDelayuS_loop:		DJNZ	R7,mDelayuS_loop
					RET
;
; ʱn,ȷ,24MHzƵ
; : A ʱ
; ʹ: A, R7
mDelaymS:			MOV		R7,#0FAH
mDelaymS_loop:		NOP
					NOP
					NOP
					NOP
					NOP
					NOP
					DJNZ	R7,mDelaymS_loop
					DEC     A
					JNZ     mDelaymS
					RET
;
; CH376д
; : A 
; ʹ: A, DPTR
xWriteCH376Cmd:		MOV		DPTR,#CH376_CMD_PORT	;˿
					MOVX	@DPTR,A
					NOP								;ʱȷдڴ1.5uS
					RET
; CH376д
; : A 
; ʹ: A, DPTR
xWriteCH376Data:	MOV		DPTR,#CH376_DAT_PORT
					MOVX	@DPTR,A
					RET
; CH376
; : A 
; ʹ: A, DPTR
xReadCH376Data:		MOV		DPTR,#CH376_DAT_PORT
					MOVX	A,@DPTR
					RET
;
; ѯCH376ж(INT#͵ƽ)
; : NC ж, CY ж
; ʹ: A, DPTR
Query376Interrupt:	MOV		DPTR,#CH376_CMD_PORT	;״̬˿
					MOVX	A,@DPTR
					RLC		A
					RET
;
; ʼCH376ΪUSBģʽ
; : NC ɹ, CY ʧ
; ʹ: A, DPTR, R7
mInitCH376Host:		MOV		A,#CMD11_SET_USB_MODE
					LCALL	xWriteCH376Cmd
					MOV		A,#06H					;03HSDģʽ
					LCALL	xWriteCH376Data
					MOV		A,#20
					LCALL	xReadCH376Data
					SETB	C
					XRL		A,#CMD_RET_SUCCESS
					JNZ		mInitCH376Host0
					CLR		C
mInitCH376Host0:	RET
;
; ڲȡݿ
; : R0 ָڲRAM,
; : R7 ݿ鳤
; ʹ: A, DPTR, R0, R6, R7
CH376ReadBlock:		MOV		A,#CMD01_RD_USB_DATA0
					LCALL	xWriteCH376Cmd
					LCALL	xReadCH376Data			;
					MOV		R7,A
					JZ		CH376ReadBlock0			;0
					MOV		R6,A
CH376ReadBlock1:	LCALL	xReadCH376Data
					MOV		@R0,A
					INC		R0
					DJNZ	R6,CH376ReadBlock1
CH376ReadBlock0:	RET
;
; ڲָдݿ
; : R0 ָڲRAM,д
; : R7 ݿ鳤
; ʹ: A, DPTR, R0, R6, R7
CH376WriteReqBlock:	MOV		A,#CMD01_WR_REQ_DATA
					LCALL	xWriteCH376Cmd
					LCALL	xReadCH376Data			;
					MOV		R7,A
					JZ		CH376WriteReqBlk0		;0
					MOV		R6,A
CH376WriteReqBlk1:	MOV		A,@R0
					INC		R0
					LCALL	xWriteCH376Data
					DJNZ	R6,CH376WriteReqBlk1
CH376WriteReqBlk0:	RET
;
; ýҪļļ
; : DPTR ָROMеļַ,0
; ʹ: A, DPTR
CH376SetFileName:	PUSH	DPL
					PUSH	DPH
					MOV		A,#CMD10_SET_FILE_NAME
					LCALL	xWriteCH376Cmd
					POP		DPH
					POP		DPL
CH376SetFileName1:	CLR		A
					MOVC	A,@A+DPTR
					INC		DPTR
					PUSH	DPL
					PUSH	DPH
					LCALL	xWriteCH376Data
					POP		DPH
					POP		DPL
					JNZ		CH376SetFileName1
					RET
;
; ȡж״̬ȡж
; : A ж״̬
; ʹ: A, DPTR
CH376GetIntStatus:	MOV		A,#CMD01_GET_STATUS
					LCALL	xWriteCH376Cmd
					LCALL	xReadCH376Data
					RET
;
; ȴCH376ж(INT#͵ƽ)ж״̬
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
Wait376Interrupt:	LCALL	Query376Interrupt
					JC		Wait376Interrupt		;ûж
					LCALL	CH376GetIntStatus		;ȡж״̬ȡж
					CJNE	A,#USB_INT_SUCCESS,Wait376Interrupt0	;Ƚж״̬
					CLR		C
					RET
Wait376Interrupt0:	SETB	C
					RET
;
; UǷ,֧SD
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
CH376DiskConnect:	MOV		A,#CMD0H_DISK_CONNECT
					LCALL	xWriteCH376Cmd
					LJMP	Wait376Interrupt
;
; ʼ̲ԴǷ
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
CH376DiskMount:		MOV		A,#CMD0H_DISK_MOUNT
					LCALL	xWriteCH376Cmd
					LJMP	Wait376Interrupt
;
; ڸĿ¼ߵǰĿ¼´ļĿ¼
; : DPTR ָROMеļַ,0
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
CH376FileOpen:		CLR		A
					MOVC	A,@A+DPTR
					PUSH	ACC
					LCALL	CH376SetFileName		;ýҪļļ
					POP		ACC
					CJNE    A,#DEF_SEPAR_CHAR1,CH376FileOpen1
					SJMP    CH376FileOpen0
CH376FileOpen1:		CJNE    A,#DEF_SEPAR_CHAR2,CH376FileOpen2
CH376FileOpen0:		MOV		A,#CMD50_WRITE_VAR32
					LCALL	xWriteCH376Cmd
					MOV		A,#VAR_CURRENT_CLUST
					LCALL	xWriteCH376Data
					CLR		A
					LCALL	xWriteCH376Data
					CLR		A
					LCALL	xWriteCH376Data
					CLR		A
					LCALL	xWriteCH376Data
					CLR		A
					LCALL	xWriteCH376Data
CH376FileOpen2:		MOV		A,#CMD0H_FILE_OPEN
					LCALL	xWriteCH376Cmd
					LJMP	Wait376Interrupt
;
; ڸĿ¼ߵǰĿ¼½ļ,ļѾôɾ
; : DPTR ָROMеļַ,0
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
CH376FileCreate:	LCALL	CH376SetFileName		;ýҪļļ
					MOV		A,#CMD0H_FILE_CREATE
					LCALL	xWriteCH376Cmd
					LJMP	Wait376Interrupt
;
; رյǰѾ򿪵ļ
; : A Ϊ0ֹļ, 0Զļ
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR
CH376FileClose:		PUSH	ACC
					MOV		A,#CMD1H_FILE_CLOSE
					LCALL	xWriteCH376Cmd
					POP		ACC
					LCALL	xWriteCH376Data
					LJMP	Wait376Interrupt
;
; ֽΪλƶǰļָ
; : R7/R6/R5/R4 ƫֽ
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ
; ʹ: A, DPTR, R4, R5, R6, R7
CH376ByteLocate:	MOV		A,#CMD4H_BYTE_LOCATE
					LCALL	xWriteCH376Cmd
					MOV		A,R4
					LCALL	xWriteCH376Data
					MOV		A,R5
					LCALL	xWriteCH376Data
					MOV		A,R6
					LCALL	xWriteCH376Data
					MOV		A,R7
					LCALL	xWriteCH376Data
					LJMP	Wait376Interrupt
;
; ֽΪλӵǰλöȡݿ
; : R0 ָڲRAM,,
;       R7/R6 ȡֽ,065535,R6Ϊֽ,ʵʹڲRAMֻּ֧ʮֽ,ʹⲿRAMֵ֧65535ֽ
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ,
;       R5/R4 ʵʶȡֽ,R4Ϊֽ
; ʹ: A, DPTR, R0, R4, R5, R6, R7
CH376ByteRead:		MOV		A,#CMD2H_BYTE_READ
					LCALL	xWriteCH376Cmd
					MOV		A,R6
					LCALL	xWriteCH376Data
					MOV		A,R7
					LCALL	xWriteCH376Data
					CLR		A
					MOV		R4,A
					MOV		R5,A
CH376ByteReadLoop:	LCALL	Wait376Interrupt
					JNC		CH376ByteReadEnd		;ҳɹ
					CJNE	A,#USB_INT_DISK_READ,CH376ByteReadErr
					LCALL	CH376ReadBlock			;ڲȡݿ,ָԶ
					MOV		A,R4
					ADD		A,R7
					MOV		R4,A					;ۼʵʽյֽ
					MOV		A,R5
					ADDC	A,#00H
					MOV		R5,A
					MOV		A,#CMD0H_BYTE_RD_GO
					LCALL	xWriteCH376Cmd
					SJMP    CH376ByteReadLoop		;
CH376ByteReadErr:	SETB	C
CH376ByteReadEnd:	RET
;
; ֽΪλǰλдݿ
; : R0 ָڲRAM,д,
;       R7/R6 дֽ,065535,R6Ϊֽ,ʵʹڲRAMֻּ֧ʮֽ,ʹⲿRAMֵ֧65535ֽ
; : A ж״̬, NC ɹ(ж״̬USB_INT_SUCCESS), CY ʧ,
;       R5/R4 ʵдֽ,R4Ϊֽ
; ʹ: A, DPTR, R0, R4, R5, R6, R7
CH376ByteWrite:		MOV		A,#CMD2H_BYTE_WRITE
					LCALL	xWriteCH376Cmd
					MOV		A,R6
					LCALL	xWriteCH376Data
					MOV		A,R7
					LCALL	xWriteCH376Data
					CLR		A
					MOV		R4,A
					MOV		R5,A
CH376ByteWriteLoop:	LCALL	Wait376Interrupt
					JNC		CH376ByteWriteEnd		;ҳɹ
					CJNE	A,#USB_INT_DISK_WRITE,CH376ByteWriteErr
					LCALL	CH376WriteReqBlock		;ڲָдݿ,ָԶ
					MOV		A,R4
					ADD		A,R7
					MOV		R4,A					;ۼʵдֽ
					MOV		A,R5
					ADDC	A,#00H
					MOV		R5,A
					MOV		A,#CMD0H_BYTE_WR_GO
					LCALL	xWriteCH376Cmd
					SJMP    CH376ByteWriteLoop		;д
CH376ByteWriteErr:	SETB	C
CH376ByteWriteEnd:	RET
;
; ROMռַƵڲRAM
; : DPTR ָROMռַԴַ
;       R0 ָڲRAMĿĵַ
; ʹ: A, DPTR, R0
mCopyStringToIRAM:	CLR		A
					MOVC	A,@A+DPTR
					INC		DPTR
					MOV		@R0,A
					INC		R0
					JNZ		mCopyStringToIRAM
					RET
;
; RAMַĳ
; : R0 ָڲRAMеַʼַ
; : A ַĳ
; ʹ: A, R0
mGetStringLength:	MOV		A,#0FFH
					DEC		R0
mGetStringLength1:	INC		R0
					INC		A
					CJNE	@R0,#00H,mGetStringLength1
					RET
;
; ״̬,ͣ,ʵӦóҪ
; : A ״̬
mStopIfError:		JC		ERROR_FOUND			;
					RET							;ɹ򷵻
ERROR_FOUND:		CLR		LED_OUT				;LED˸ʾ
					MOV		A,#100
					LCALL	mDelaymS
					SETB	LED_OUT
					MOV		A,#100
					LCALL	mDelaymS
					SJMP	ERROR_FOUND
;
;
; Ӧó, ʾ
ASM_MAIN:			MOV		SP,#0CFH			;ջ
					CLR		LED_OUT				;LEDһʾ
					MOV		A,#100
					LCALL	mDelaymS
					SETB	LED_OUT

					LCALL	mInitCH376Host		;ʼCH376ΪUSBģʽ
					LCALL	mStopIfError

; ѭ, ȴU̲벢, ʵϵƬ, ҪдUʱٲѯU״̬
WAIT_DISK_IN:		LCALL	CH376DiskConnect	;UǷ,֧SD,SDɵƬֱӲѯSDĲ״̬
					JNC		DISK_IN_NOW			;UѾ,USB豸Ѿ
					MOV		A,#100
					LCALL	mDelaymS			;Ƭ,Ƶѯ
					SJMP	WAIT_DISK_IN
DISK_IN_NOW:		MOV		A,#250
					LCALL	mDelaymS			;ʱ,ѡ,еUSB洢Ҫʮ߸ʱ
					CLR  	LED_OUT				;LED

; UǷ׼
					MOV		R2,#10
IS_DISK_READY:		LCALL	CH376DiskMount		;ʼ̲ԴǷ
					JNC		DISK_READY_OK		;׼
					MOV		A,#50
					LCALL	mDelaymS
					DJNZ	R2,IS_DISK_READY	;ȴ,еUǷδ׼,Ա
DISK_READY_OK:

; Դļ
					MOV		DPTR,#FILE_NAME		;ָROMеļַ
					LCALL	CH376FileOpen		;ڸĿ¼ߵǰĿ¼´ļ
					JNC     FILE_OPEN_EXIST		;ļѾ
					CJNE	A,#ERR_MISS_FILE,FILE_OPEN_ERR
; ļ½ļ
					MOV		DPTR,#FILE_NAME		;ָROMеļַ
					LCALL	CH376FileCreate		;ڸĿ¼ߵǰĿ¼½ļ
					LCALL	mStopIfError
					SJMP	FILE_OPEN_CREATE
; ļ򿪲ʧ
FILE_OPEN_ERR:		SETB	C
					LCALL	mStopIfError
; ļѾ,ƶǰļָ뵽ļβԱ
FILE_OPEN_EXIST:

;					MOV		A,#30				;ȡֽ,ܳڲĴС
;					MOV		R2,A
;					MOV		R6,A
;					MOV		R7,#00H
;					MOV		R0,#MY_BUFFER		;ָڲRAM,Ŷݿ
;					LCALL	CH376ByteRead		;ֽΪλӵǰλöȡݿ
;					LCALL	mStopIfError
;					MOV		A,R4				;ʵʶȡֽ
;					XRL		A,R2				;ȡֽ
;					JNZ		END_OF_FILE			;ʵֽ˵ļĩβ,ļ
;					NOP							;ļδ,ȡ

					MOV		R4,#0FFH			;Ƶļβ
					MOV		R5,#0FFH
					MOV		R6,#0FFH
					MOV		R7,#0FFH
					LCALL	CH376ByteLocate		;ֽΪλƶǰļָ
					LCALL	mStopIfError
FILE_OPEN_CREATE:

; ʼļд
					MOV		DPTR,#STR_WRITE_1
					MOV		R0,#MY_BUFFER
					LCALL	mCopyStringToIRAM	;ROMռַƵڲRAM
					MOV		R0,#MY_BUFFER
					LCALL	mGetStringLength	;RAMַĳ
					MOV		R6,A				;дֽ
					MOV		R7,#00H
					MOV		R0,#MY_BUFFER		;ָڲRAM
					LCALL	CH376ByteWrite		;ֽΪλǰλдݿ
					LCALL	mStopIfError
; ʼļд,ڶ
					MOV		DPTR,#STR_WRITE_2
					MOV		R0,#MY_BUFFER
					LCALL	mCopyStringToIRAM	;ROMռַƵڲRAM
					MOV		R0,#MY_BUFFER
					LCALL	mGetStringLength	;RAMַĳ
					MOV		R6,A				;дֽ
					MOV		R7,#00H
					MOV		R0,#MY_BUFFER		;ָڲRAM
					LCALL	CH376ByteWrite		;ֽΪλǰλдݿ
					LCALL	mStopIfError
					MOV		A,#01H				;Զļ
					LCALL   CH376FileClose		;رյǰѾ򿪵ļ
					LCALL	mStopIfError

; ʾ,ȴṴγ
					SETB 	LED_OUT				; LED
WAIT_DISK_OUT:		LCALL	CH376DiskConnect	;UǷ,ȴṴγ,SDɵƬֱӲѯSDĲ״̬
					JC		DISK_OUT_NOW		;UѾϿ
					MOV		A,#100
					LCALL	mDelaymS			;Ƭ,Ƶѯ
					SJMP	WAIT_DISK_OUT

DISK_OUT_NOW:		MOV		A,#200
					LCALL	mDelaymS
					LJMP	WAIT_DISK_IN		;ѭ,һU
;
END
