/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾд,޸ļ,ѯʣռ,
   ڽADCģɼӵUļMY_ADC.TXT,ΪٶȶΪλдUļ,֧SD,
   ʾģʽ´,ͬʱ˲ͽϸٶ,ҪƬϵͳṩ㹻RAMΪļݻFILE_DATA_BUF */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#define		EN_DISK_QUERY		1	/* ô̲ѯ */
#define		EN_SECTOR_ACCESS	1	/* д */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

UINT16	total;		/* ¼ǰFILE_DATA_BUFеݳ */
UINT32	NewSize;	/* ʱ */
UINT8	xdata	FileDataBuf[0x4000];	/* ļ,̫Сٶ */

/* ׼дU̵ݽмл,ϳɴݿʱͨCH376дU */
/* ĺô: ٶ(ΪݿдʱЧʸ), U(Uڲڴ,Ƶд) */
void	mFlushBufferToDisk( UINT8 force )
/* force = 0 Զˢ(黺еݳ,д,ʱڻ), force != 0 ǿˢ(ܻежٶд,ͨϵͳػǰӦǿд) */
{
	UINT8	s;
	if ( force ) {  /* ǿˢ */
		s = ( total + DEF_SECTOR_SIZE - 1 ) / DEF_SECTOR_SIZE;  /* еֽתΪ(DEF_SECTOR_SIZE),ȼDEF_SECTOR_SIZE-1ȷдͷ */
		if ( s ) {  /*  */
			s = CH376SecWrite( FileDataBuf, s, NULL );  /* Ϊλļд,д뻺е,ͷ */
			mStopIfError( s );
/* ЩUܻ̿Ҫдݺȴһܼ,,ĳЩUзݶʧ,ÿдݺʱټ */
			mDelaymS( 1 );  /* дʱ,ѡ,U̲Ҫ */
			memcpy( FileDataBuf, & FileDataBuf[ total & ~ ( DEF_SECTOR_SIZE - 1 ) ], total & ( DEF_SECTOR_SIZE - 1 ) );  /* ղдU̵ͷݸƵͷ */
			total &= DEF_SECTOR_SIZE - 1;  /* ֻʣ¸ղдU̵ͷ,ڻΪ˷Ժ׷ */
		}
		NewSize = CH376GetFileSize( );  /* ȡǰļ,ûͷ,ôļDEF_SECTOR_SIZEı */
		if ( total ) NewSize -= DEF_SECTOR_SIZE - total;  /* Ϊλ,ͷ,ļ(Чݵĳ) */
		CH376WriteVar32( VAR_FILE_SIZE, NewSize );  /* ȷĵǰļдCH376ڴ */
		printf( "Current file size is %ld\n", NewSize );
		s = CH376SecWrite( FileDataBuf, 0, NULL );  /* д0,ʵˢļ,CH376ڴеǰļϢдU̻SD */
		mStopIfError( s );
		s = CH376SecLocate( 0xFFFFFFFF );  /* »صԭļβ,Ϊλ,Իļβͷ,дݽβͷ,ͷһݸڻ, */
		mStopIfError( s );
	}
	else if ( total >= sizeof( FileDataBuf ) - DEF_SECTOR_SIZE ) {  /* еݿҪ,ӦȽеԭдU */
		s = CH376SecWrite( FileDataBuf, (UINT8)( total / DEF_SECTOR_SIZE ), NULL );  /* еֽתΪ(DEF_SECTOR_SIZE),ͷȲ,Ϊλļд */
		mStopIfError( s );
		memcpy( FileDataBuf, & FileDataBuf[ total & ~ ( DEF_SECTOR_SIZE - 1 ) ], total & ( DEF_SECTOR_SIZE - 1 ) );  /* ղδдU̵ͷݸƵͷ */
		total &= DEF_SECTOR_SIZE - 1;  /* ֻʣ¸ղδдU̵ͷ */
/* ע,˴U̻SDеļȻǰֵ,ʱͻȻϵ,ôȻϵU/SD,ļûаЩ,³Ӧó޷ȡ */
	}
}

main( ) {
	UINT8	s;
	UINT8	month, date, hour;
	UINT16	year, adc;

	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ10*50mS */
		for ( s = 0; s < 10; s ++ ) {  /* ȴʱ,10*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ʼ̲ԴǷ */
		}
//		s = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
//		if ( s == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
//			buf[ s ] = 0;
//			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
//		}

/* U̻SDʣռ */
		printf( "DiskQuery: " );
		s = CH376DiskQuery( (PUINT32)buf );  /* ѯʣռϢ, */
		mStopIfError( s );
//		printf( "free cap = %ld MB\n", *(PUINT32)buf * DEF_SECTOR_SIZE / 1000000 );  /* δС,1MΪֽڵλ */
		printf( "free cap = %ld MB\n", *(PUINT32)buf / ( 1000000 / DEF_SECTOR_SIZE ) );  /* һеļܻ,˳ */

/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		s = CH376FileOpen( "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
		if ( s == USB_INT_SUCCESS ) {  /* ļڲѾ,ƶļָ뵽βԱ */
			NewSize = CH376GetFileSize( );  /* ȡǰļ,ûͷ,ôļDEF_SECTOR_SIZEı */
			printf( "File size = %ld\n", NewSize );
			printf( "Locate tail\n" );
			s = CH376SecLocate( 0xFFFFFFFF );  /* ΪλƵļβ,ļβвһͷ򱻺,ôͷݽܱдݸ */
			mStopIfError( s );
			total = NewSize & ( DEF_SECTOR_SIZE - 1 );  /* ϴαļʱβͷ,ôȡͷֽ,ȵ */
			printf( "Read last tail = %d Bytes\n", total );
			if ( total ) {  /* ԭβͷ,ôȵڴ,Ա */
				s = CH376SecRead( FileDataBuf, 1, NULL );  /* ļȡβͷ */
				mStopIfError( s );
				s = CH376SecLocate( 0xFFFFFFFF );  /* »صԭļβ,дݽԭβͷ,ԭͷݸղѾڴ, */
				mStopIfError( s );
			}
		}
		else if ( s == ERR_MISS_FILE ) {  /* ûҵļ,½ļ */
			printf( "Create\n" );
			s = CH376FileCreate( NULL );  /* ½ļ,ļѾɾ½,ṩļ,ղѾṩCH376FileOpen */
			mStopIfError( s );
			total = 0;  /* ǰûͷ */
			NewSize = 0;
		}
		else mStopIfError( s );  /* ļʱ */
		printf( "Write begin\n" );
		total += sprintf( FileDataBuf + total, "ڱ֮ǰ,ļݵĳ %ld ֽ\xd\xa", NewSize );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 0 );  /* Զˢ»,黺Ƿ,д */
		printf( "Write ADC data\n" );
		TR0=1;  /* öʱ0ļֵADC */
		for ( month = 1; month != 12; month ++ ) {  /* Ϊ԰ûʵʱʱоƬ,ѭʽģ· */
			for ( date = 1; date != 30; date ++ ) {  /* Ϊ԰ûʵʱʱоƬ,ѭʽģ */
				year = 2004;  /* ٶΪ2004 */
				hour = TL1 & 0x1F;  /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*				adc = get_adc_data( ); */
				adc = ( (UINT16)TH0 << 8 ) | TL0;  /* Ϊ԰ûADC,öʱ0ļADCʾ */
				total += sprintf( FileDataBuf + total, "Year=%04d, Month=%02d, Date=%02d, Hour=%02d, ADC_data=%u\xd\xa", year, (UINT16)month, (UINT16)date, (UINT16)hour, adc );  /* ݸʽΪһַ */
				if ( month == 6 && ( date & 0x0F ) == 0 ) mFlushBufferToDisk( 1 );  /* ǿˢ»,ǿˢ»,ͻȻϵԼݶʧ */
				else mFlushBufferToDisk( 0 );  /* Զˢ»,黺Ƿ,д */
				printf( "Current total is %d\n", total );  /* ڼؼ */
			}
		}
		printf( "Write end\n" );
		total += sprintf( FileDataBuf + total, " ********************************* " );  /* ӵβ,ۼƻڵݳ */
		total += sprintf( FileDataBuf + total, "εADCݵ˽,򼴽˳\xd\xa" );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 1 );  /* ǿˢ»,ΪϵͳҪ˳,Աǿˢ */
		printf( "Close\n" );
		s = CH376FileClose( FALSE );  /* رļ,ģʽͨԶļ,Ϊǿˢ»ʱѾļ,ﲻҪԶļ */
		mStopIfError( s );

		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
