/* CH376оƬ Ӳ׼첽ӵӲ V1.0 */
/* ṩI/Oӿӳ */

#include	"HAL.H"

/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH376оƬ
      TXD                  RXD
      RXD                  TXD       */

#define CH376_INT_WIRE			INT0	/* ٶCH376INT#,δôҲͨѯж״̬ʵ */

#define	UART_INIT_BAUDRATE	9600	/* ĬͨѶ9600bps,ͨӲ趨ֱѡߵCH376ĬͨѶ */
#define	UART_WORK_BAUDRATE	57600	/* ʽͨѶ57600bps */

void	CH376_PORT_INIT( void )  /* ʹ첽ڶдʱ,Խгʼ */
{
/* Ƭֻһ,ôֹͨϢ */
	SCON = 0x50;
	PCON = 0x80;
//	TL2 = RCAP2L = 0 - 18432000/32/UART_INIT_BAUDRATE; /* 18.432MHz */
	TL2 = RCAP2L = 0 - 24000000/32/UART_INIT_BAUDRATE; /* 24MHz */
/* ͨӲ趨ֱѡߵCH376ĬͨѶ */
	TH2 = RCAP2H = 0xFF;
	T2CON = 0x34;  /* ʱ2ڴڵĲʷ */
	RI = 0;
}

#ifdef	UART_WORK_BAUDRATE
void	SET_WORK_BAUDRATE( void )  /* ƬлʽͨѶ */
{
//	TL2 = RCAP2L = 0 - 18432000/32/UART_WORK_BAUDRATE; /* 18.432MHz */
	TL2 = RCAP2L = 0 - 24000000/32/UART_WORK_BAUDRATE; /* 24MHz */
	RI = 0;
}
#endif

#define	xEndCH376Cmd( )  /* CH376,SPIӿڷʽ */

void	xWriteCH376Cmd( UINT8 mCmd )  /* CH376д */
{
	TI = 0;
	SBUF = SER_SYNC_CODE1;  /* ĵ1ͬ */
	while ( TI == 0 );
	TI = 0;
	SBUF = SER_SYNC_CODE2;  /* ĵ2ͬ */
	while ( TI == 0 );
	TI = 0;
	RI = 0;
	SBUF = mCmd;  /*  */
	while ( TI == 0 );
}

void	xWriteCH376Data( UINT8 mData )  /* CH376д */
{
	TI = 0;
	SBUF = mData;  /*  */
	while ( TI == 0 );
}

UINT8	xReadCH376Data( void )  /* CH376 */
{
	UINT32	i;
	for ( i = 0; i < 500000; i ++ ) {  /* ֹʱ */
		if ( RI ) {  /* ڽյ */
			RI = 0;
			return( SBUF );  /*  */
		}
	}
	return( 0 );  /* Ӧ÷ */
}

/* ѯCH376ж(INT#͵ƽ) */
UINT8	Query376Interrupt( void )
{
#ifdef	CH376_INT_WIRE
	return( CH376_INT_WIRE ? FALSE : TRUE );  /* CH376жֱӲѯж */
#else
	if ( RI ) {  /* δCH376жѯж״̬ */
		RI = 0;
		return( TRUE );
	}
	else return( FALSE );
#endif
}

UINT8	mInitCH376Host( void )  /* ʼCH376 */
{
	UINT8	res;
	CH376_PORT_INIT( );  /* ӿӲʼ */
	xWriteCH376Cmd( CMD11_CHECK_EXIST );  /* ԵƬCH376֮ͨѶӿ */
	xWriteCH376Data( 0x65 );
	res = xReadCH376Data( );
//	xEndCH376Cmd( );  // 첽ڷʽҪ
	if ( res != 0x9A ) return( ERR_USB_UNKNOWN );  /* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
#ifdef	UART_WORK_BAUDRATE
	xWriteCH376Cmd( CMD21_SET_BAUDRATE );  /* ôͨѶ */
#if		UART_WORK_BAUDRATE >= 6000000/256
	xWriteCH376Data( 0x03 );
	xWriteCH376Data( 256 - 6000000/UART_WORK_BAUDRATE );
#else
	xWriteCH376Data( 0x02 );
	xWriteCH376Data( 256 - 750000/UART_WORK_BAUDRATE );
#endif
	SET_WORK_BAUDRATE( );  /* ƬлʽͨѶ */
	res = xReadCH376Data( );
//	xEndCH376Cmd( );  // 첽ڷʽҪ
	if ( res != CMD_RET_SUCCESS ) return( ERR_USB_UNKNOWN );  /* ͨѶлʧ,ͨӲλCH376 */
#endif
	xWriteCH376Cmd( CMD11_SET_USB_MODE );  /* 豸USBģʽ */
	xWriteCH376Data( 0x05 );
//	mDelayuS( 20 );  // 첽ڷʽҪ
	res = xReadCH376Data( );
//	xEndCH376Cmd( );  // 첽ڷʽҪ
	if ( res == CMD_RET_SUCCESS ) return( USB_INT_SUCCESS );
	else return( ERR_USB_UNKNOWN );  /* ģʽ */
}
